package file;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.RandomAccessFile;

public class Main {
	
	private BufferedWriter out;
	private BufferedWriter log;
	private String currentFileName;
	private String prefixo;
	private String sufixo;
	private String filePrefix;
	private String fileSufix;
	private boolean skip;
	private int writeCount;
	public void LOG(String string){
		try {	                		
    		
    		log.write(string + "\n");	        			
    	           	              
         }
         catch (IOException e) {
         }        
	}
	
	public Main()
	{
		out = null;
		prefixo = "<Conditional Code=\"U\">\n\t<Model Index=\"-\">";
		sufixo = "</Model>\n\t<Model Index=\"U\">";
		currentFileName = "";
		filePrefix = "";
		fileSufix = "";
		skip = false;
		writeCount = 0;
		
		try {
												
			log = new BufferedWriter(new FileWriter("log.txt"));			
						
		} catch (IOException e) {	        			
			e.printStackTrace();
		}			
	}
	
	public void createFile() {
		currentFileName = filePrefix + fileSufix + ".xml";
					
		try {
			if (out == null && skip == false)
			{		
				if (!filePrefix.equals("")) {
					// Creates the FILE
					out = new BufferedWriter(new FileWriter(currentFileName));
					out.write("                                                                                                                               \n");
					writeCount = 0;
				}
			}
			else {
				System.out.println("\nError: File " + currentFileName + " not created");
				LOG("\nError: File " + currentFileName + " not created");
			}
			System.out.println("\nCreated File: " + currentFileName);
			LOG("\nCreated File: " + currentFileName);
			
		} catch (IOException e) {	        			
			e.printStackTrace();
		}				
	}
	
	public void tryToCloseFile(){
		try {
			if (out != null)
			{										
				out.close();
				out = null;
				
				
				
				RandomAccessFile f = new RandomAccessFile(new File(currentFileName), "rw");
	            f.getChannel().position(0);         
	            f.writeBytes("<!------------------------------- " + filePrefix + fileSufix + " Count: " + writeCount + " ------------------------------->");
	            f.close();
	            
	            System.out.println("\nFile " + currentFileName + " closed.");
				LOG("\nFile " + currentFileName + " closed.");
				currentFileName = " ";	
			}
			else 
			{
				System.out.println("\nNo file open, nothing to close");
				LOG("\nNo file open, nothing to close");
			}
			
			
		} catch (IOException e) {	        			
			e.printStackTrace();
		}		
	}

	public File[] listf(String directoryName) {

		
	    // .............list file
	    File directory = new File(directoryName);

	    // get all the files from a directory
	    File[] fList = directory.listFiles();

	    for (File file : fList) {
	    		    	   	    	
	    	
	        if (file.isDirectory()) {	        		        
	        	
	        	if (file.getName().equals("1_phm"))
	        	{
	        		filePrefix = "Warrior";
	        		skip = true;
	        	}	        	
	        	else if (file.getName().equals("2_phw"))
	        	{
	        		filePrefix = "Sorceress_";
	        		skip = false;
	        	}
	        	else if (file.getName().equals("3_pew"))
	        	{
	        		filePrefix = "Ranger_";
	        		skip = false;
	        	}
	        	else if (file.getName().equals("4_pgb"))
	        	{
	        		filePrefix = "Berserker_";
	        		skip = true;
	        	}
	        	else if (file.getName().equals("5_pbw"))
	        	{
	        		filePrefix = "Tamer_";
	        		skip = false;
	        	}
	        	else if (file.getName().equals("6_pkm"))
	        	{
	        		filePrefix = "Samurai_";
	        		skip = true;
	        	}
	        	else if (file.getName().equals("7_pvw"))
	        	{
	        		filePrefix = "Valyrie_";
	        		skip = false;
	        	}
	        	else if (file.getName().equals("8_pwm"))
	        	{
	        		filePrefix = "Wizard_";
	        		skip = true;
	        	}
	        	else if (file.getName().equals("8_pww"))
	        	{
	        		filePrefix = "Witch_";
	        		skip = false;
	        	}
	        	else if (file.getName().equals("13_pnm"))
	        	{
	        		filePrefix = "Ninja_";
	        		skip = true;
	        	}
	        	else if (file.getName().equals("13_pnw"))
	        	{
	        		filePrefix = "Female_Ninja_";
	        		skip = true;
	        	}	
	        	else if (file.getName().equals("22_pkww"))
	        	{
	        		filePrefix = "Korean_";
	        		skip = true;
	        	}	
	        	
	        	if (file.getName().equals("10_lowerbody")) {
	        		fileSufix = "Lowerbody";
	        		createFile();
	        	}
	        	else if (file.getName().equals("38_underwear")) {
	        		fileSufix = "Underwear";
	        		createFile();
	        	}	        
	        	else if (file.getName().equals("9_upperbody")) {
	        		fileSufix = "Upperbody";
	        		createFile();
	        	}	  
	        	
	        	else if (file.getName().equals("12_foot")) {
	        		fileSufix = "Foot";
	        		createFile();
	        	}	
	        	
	        	else if (file.getName().equals("11_hand")) {
	        		fileSufix = "Hand";
	        		createFile();
	        	}	
	        	
	        	else if (file.getName().equals("28_enchantarm")) {
	        		fileSufix = "Weapon";
	        		createFile();
	        	}	
	        	
	        	else if (file.getName().equals("33_talisman")) {
	        		fileSufix = "Talisman";
	        		createFile();
	        	}	        
	        	
	        	
	            this.listf(file.getAbsolutePath());
	        }
	        else if (file.isFile()) {
	      	       
	        	String caminhoCompleto = file.getAbsolutePath();
	        	String caminhoParcial = caminhoCompleto.replace("D:\\BDO\\Paz\\character\\model\\", "");
	        	caminhoParcial = caminhoParcial.replace("\\", "/");
	        	caminhoParcial = caminhoParcial.toUpperCase();
	        	
	        	try {	            
	        		
	        		if(out != null && skip == false)
	        		{	        			        			   
	        			System.out.println("WRITING: " + caminhoParcial);
	        			LOG("WRITING: " + caminhoParcial);
	        			
	        			if (fileSufix.equals("Underwear") == false) {	        				
		        			// WRITES ON THE FILE
		        			out.write(prefixo + caminhoParcial + sufixo + caminhoParcial + "</Model>\n</Conditional>\n\n");
	        			}
	        			else {
	        				String prefixoUnderwear = "<Conditional Code=\"I\">\n\t<Model Index=\"-\">";
	        				String sufixoUnderwear = "</Model>\n\t<Model Index=\"I\">";
	        				out.write(prefixoUnderwear + caminhoParcial + sufixoUnderwear + caminhoParcial + "</Model>\n</Conditional>\n\n");
	        			}
	        			
	        			writeCount++;
	        		}
	        		else
	        		{	        			
	        			System.out.println("Skipping: " + caminhoParcial);
	        			LOG("Skipping: " + caminhoParcial);;	        				        		
	        		}	               	              
	             }
	             catch (IOException e) {
	             }          
	        } 
	    }
	    System.out.println("End of Folder");
	    LOG("End of Folder");
	    tryToCloseFile();
	    return fList;
	}   
	
	public static void main(String[] args) {
	
		
		
		Main m = new Main();
		  
		m.listf("D:/BDO/Paz/character/model/1_pc/") ;
		
		
		
         System.out.println("Completed!");
         m.LOG("Completed!");
	}

}
